scala.tools.nsc.backend.icode.GenICode

# ICodePhase

###
Related Doc: package GenICode

#### class ICodePhase extends StdPhase

Source
  GenICode.scala

Linear Supertypes
GenICode.StdPhase, GlobalPhase, reflect.internal.Phase, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ICodePhase
2. StdPhase
3. GlobalPhase
4. Phase
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ICodePhase(prev: Phase)

### Type Members

1. #### sealed abstract class Cleanup extends AnyRef

2. #### class Context extends AnyRef

   The Context class keeps information relative to the current state in code generation

3. #### class DuplicateLabels extends Global.Transformer

   Tree transformer that duplicates code and at the same time creates fresh symbols for existing labels.

   Tree transformer that duplicates code and at the same time creates fresh symbols for existing labels. Since labels may be used before they are defined (forward jumps), all labels found are mapped to fresh symbols. References to the same label (use or definition) will remain consistent after this transformation (both the use and the definition of some label l will be mapped to the same label l').

   Note: If the tree fragment passed to the duplicator contains unbound label names, the bind to the outer labeldef will be lost! That's because a use of an unbound label l will be transformed to l', and the corresponding label def, being outside the scope of this transformation, will not be updated.

   All LabelDefs are entered into the context label map, since it makes no sense to delay it any more: they will be used at some point.

4. #### case class Finalizer (f: Global.Tree, ctx: Context) extends Cleanup with Product with Serializable

5. #### type Id = Int

   Definition Classes
     Phase

6. #### case class MonitorRelease (m: Global.icodes.Local) extends Cleanup with Product with Serializable

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodePhase to any2stringadd[ICodePhase] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodePhase, B)

   Implicit information
     This member is added by an implicit conversion from ICodePhase to ArrowAssoc[ICodePhase] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def apply(unit: Global.CompilationUnit): Unit

   Definition Classes
     ICodePhase → GlobalPhase

7. #### final def applyPhase(unit: Global.CompilationUnit): Unit

   Definition Classes
     GlobalPhase

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def cancelled(unit: Global.CompilationUnit): Boolean

   Is current phase cancelled on this unit?

   Is current phase cancelled on this unit?

   Definition Classes
     GlobalPhase

10. #### def checkable: Boolean

    Definition Classes
      Phase

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def description: String

    Definition Classes
      ICodePhase → Phase

13. #### def duplicateFinalizer(boundLabels: Set[Global.Symbol], targetCtx: Context, finalizer: Global.Tree): Global.Tree

14. #### def ensuring(cond: (ICodePhase) ⇒ Boolean, msg: ⇒ Any): ICodePhase

    Implicit information
      This member is added by an implicit conversion from ICodePhase to Ensuring[ICodePhase] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (ICodePhase) ⇒ Boolean): ICodePhase

    Implicit information
      This member is added by an implicit conversion from ICodePhase to Ensuring[ICodePhase] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodePhase

    Implicit information
      This member is added by an implicit conversion from ICodePhase to Ensuring[ICodePhase] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): ICodePhase

    Implicit information
      This member is added by an implicit conversion from ICodePhase to Ensuring[ICodePhase] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(other: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Phase → AnyRef → Any

20. #### def erasedTypes: Boolean

    Definition Classes
      GlobalPhase → Phase

21. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

22. #### def findHostClass(selector: Global.Type, sym: Global.Symbol): Global.Symbol

    If the selector type has a member with the right name, it is the host class; otherwise the symbol's owner.

23. #### def flagMask: Long

    Definition Classes
      Phase

24. #### def flatClasses: Boolean

    Definition Classes
      GlobalPhase → Phase

25. #### val fmask: Long

    Definition Classes
      Phase

26. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodePhase to StringFormat[ICodePhase] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### def gen(tree: Global.Tree, ctx: Context): Context

28. #### def gen(trees: List[Global.Tree], ctx: Context): Context

29. #### def gen(tree: Global.Tree): Context

30. #### def genCast(from: Global.icodes.TypeKind, to: Global.icodes.TypeKind, ctx: Context, cast: Boolean): Unit

31. #### def genCoercion(tree: Global.Tree, ctx: Context, code: Int): Unit

    Generate coercion denoted by "code"

32. #### def genConversion(from: Global.icodes.TypeKind, to: Global.icodes.TypeKind, ctx: Context, cast: Boolean): Unit

33. #### def genEqEqPrimitive(l: Global.Tree, r: Global.Tree, ctx: Context)(thenCtx: Context, elseCtx: Context): Boolean

    Generate the "==" code for object references.

    Generate the "==" code for object references. It is equivalent of if (l eq null) r eq null else l.equals(r);

    l

      left-hand side of the '=='

    r

      right-hand side of the '=='

    ctx

      current context

    thenCtx

      target context if the comparison yields true

    elseCtx

      target context if the comparison yields false

    returns

      true if either branch can continue normally to a follow on block, false otherwise

34. #### def genScalaHash(tree: Global.Tree, ctx: Context): Context

    Generate the scala ## method.

35. #### def genStringConcat(tree: Global.Tree, ctx: Context): Context

    Generate string concatenation.

36. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

37. #### def getMaxType(ts: List[Global.Type]): Global.icodes.TypeKind

38. #### def getZeroOf(k: Global.icodes.TypeKind): Global.icodes.Instruction

39. #### def hasNext: Boolean

    Definition Classes
      Phase

40. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      Phase → AnyRef → Any

41. #### val id: Id

    Definition Classes
      Phase

42. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

43. #### def isPrimitive(fun: Global.Symbol): Boolean

    Is the given symbol a primitive operation?

44. #### def iterator: collection.Iterator[reflect.internal.Phase]

    Definition Classes
      Phase

45. #### def keepsTypeParams: Boolean

    Definition Classes
      Phase

46. #### def liftStringConcat(tree: Global.Tree): List[Global.Tree]

    Returns a list of trees that each should be concatenated, from left to right.

    Returns a list of trees that each should be concatenated, from left to right. It turns a chained call like "a".+("b").+("c") into a list of arguments.

47. #### def mayCleanStack(tree: Global.Tree): Boolean

    Does this tree have a try-catch block?

48. #### def name: String

    Definition Classes
      StdPhase → Phase

49. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

50. #### def newFlags: Long

    Definition Classes
      StdPhase → Phase

51. #### def next: reflect.internal.Phase

    Definition Classes
      Phase

52. #### def nextFlags: Long

    Definition Classes
      StdPhase → Phase

53. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

54. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

55. #### val prev: reflect.internal.Phase

    Definition Classes
      Phase

56. #### def prune(method: Global.icodes.IMethod): Unit

    If the block consists of a single unconditional jump, prune it by replacing the instructions in the predecessor to jump directly to the JUMP target of the block.

57. #### def refChecked: Boolean

    Definition Classes
      GlobalPhase → Phase

58. #### def run(): Unit

    Definition Classes
      ICodePhase → GlobalPhase → Phase

59. #### def savingCleanups[T](ctx: Context)(body: ⇒ T): T

60. #### def specialized: Boolean

    Definition Classes
      GlobalPhase → Phase

61. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

62. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      Phase → AnyRef → Any

63. #### var unit: Global.CompilationUnit

64. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

65. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

66. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

67. #### final def withCurrentUnit(unit: Global.CompilationUnit)(task: ⇒ Unit): Unit

    Definition Classes
      GlobalPhase

68. #### def →[B](y: B): (ICodePhase, B)

    Implicit information
      This member is added by an implicit conversion from ICodePhase to ArrowAssoc[ICodePhase] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from GenICode.StdPhase

### Inherited from GlobalPhase

### Inherited from reflect.internal.Phase

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodePhase to any2stringadd[ICodePhase]

### Inherited by implicit conversion StringFormat from ICodePhase to StringFormat[ICodePhase]

### Inherited by implicit conversion Ensuring from ICodePhase to Ensuring[ICodePhase]

### Inherited by implicit conversion ArrowAssoc from ICodePhase to ArrowAssoc[ICodePhase]

### Ungrouped